UVA 10534--Wavio Sequence+二分+DP

开始的时候一直想不到一个合适的状态转移方程;

后面想到可以分别求以中间那个数为终点和起点的最长上升子序列的长度,

然后以这个数为中心数的Wavio Sequence的长度就是其中短的那个值*2-1的值;

然后我们取所有数Wavio Sequence的最大长度作为答案。

这个题目卡了n^2的求最长上升子序列的算法,必须用nlgn算法才能过。

代码如下:

#include<iostream>
#include<cstring>
#include<cstdio>
#include<algorithm>
using namespace std;

int a[10010],n;
int d1[10010],d2[10010];
int d[10010];

int lower_bound(int* A,int x,int y,int v)
{
    int m;
    while(x<y)
    {
        m=x+(y-x)/2;
        if(A[m]>=v)
            y=m;
        else
            x=m+1;
    }
    return x;
}

int main()
{
    while(scanf("%d",&n)!=EOF)
    {
         for(int i=1;i<=n;i++)
             scanf("%d",&a[i]);
         for(int i=1;i<=n;i++)
            d1[i]=1,d2[i]=1;
         int len=1;
         d[1]=a[1];
         for(int i=2;i<=n;i++)
         {
             if(a[i]>d[len])
             {
                 d[++len]=a[i];
                 d1[i]=len;
             }
             else
             {
                 int t=lower_bound(d,1,len,a[i]);
                 d[t]=a[i];
                 d1[i]=t;
             }
         }
         len=1;
         d[1]=a[n];
         for(int i=n-1;i>=1;i--)
         {
             if(a[i]>d[len])
             {
                 len++;
                 d[len]=a[i];
                 d2[i]=len;
             }
             else
             {
                 int t=lower_bound(d,1,len,a[i]);
                 d[t]=a[i];
                 d2[i]=t;
             }
         }
        int ans=0;
        for(int i=1;i<=n;i++)
            ans=max(ans,min(d1[i],d2[i])*2-1);
        printf("%d\n",ans);
    }
  return 0;
}
时间: 2024-10-12 19:14:41

UVA 10534--Wavio Sequence+二分+DP的相关文章

LIS UVA 10534 Wavio Sequence

题目传送门 1 /* 2 LIS:应用,nlogn的做法,首先从前扫到尾,记录每个位置的最长上升子序列,从后扫到头同理. 3 因为是对称的,所以取较小值*2-1再取最大值 4 */ 5 /************************************************ 6 * Author :Running_Time 7 * Created Time :2015-8-5 21:38:32 8 * File Name :UVA_10534.cpp 9 ***************

uva 10534 Wavio Sequence LIS

// uva 10534 Wavio Sequence // // 可以将题目转化为经典的LIS. // 从左往右LIS记作d[i],从右往左LIS记作p[i]; // 则最后其中的min(d[i],p[i])就是这个波动序列的一半 // 在这最后的min(d[i],p[i]) * 2 + 1 的最大值就是我们所要求的答案 // // 这题开始想的最后的答案是d[i]==p[i]的时候求最大. // 但是这样是不对的,例如n=4, // 1,3,1,0 // 最长的应该是3,但是我的答案是1,明

UVa 10534 Wavio Sequence (最长递增子序列 DP 二分)

Wavio Sequence  Wavio is a sequence of integers. It has some interesting properties. ·  Wavio is of odd length i.e. L = 2*n + 1. ·  The first (n+1) integers of Wavio sequence makes a strictly increasing sequence. ·  The last (n+1) integers of Wavio s

UVa 10534 Wavio Sequence ( DP 二分 最长递增子序列 )

题意  求一个序列a某一位的最长递增序列(lis)和最长递减序列(lds)中最小值的最大值 开始直接用DP写了   然后就超时了  后来看到别人说要用二分把时间复杂度优化到O(n*logn)   果然如此   用一个栈s保存长度为i的LIS的最小尾部s[i]  top为栈顶即当前LIS的长度  初始s[1]=a[1]  top=1 遍历整个序列  当a[i]>s[top]时  a[i]入栈 in[i]=top   否则 在栈中查找(二分)第一个大于等于a[i]的下标pos  并替换  这样就增加

UVA 10534 Wavio Sequence(二分 + 最长上升子序列)

Wavio Sequence 题目: 题目大意: 题目是给一个序列,然后再其序列中找一个子序列,这个子序列符合前一半是递增的序列,后半部分是递减的序列,并且是这个序列中所有符合条件的子序列中最长的,输出其长度. 思路分析: 题目读懂以后,解法就迎刃而出了,很显然,正着求一个最长上升子序列,倒着求一个最长上升子序列.然后从这两个序列中找重合的位置最符合题意的,不过在这道题中,需要标记到每一位的最长上升子序列,因为每一位都可能成为符合题意的子序列的中间那一位置.这就需要用两个数组来标记,一个标记正方

【UVa】Wavio Sequence(dp)

http://uva.onlinejudge.org/index.php?option=com_onlinejudge&Itemid=8&page=show_problem&problem=1475 正反一次lis然后去min{左,右}*2-1即可 #include <cstdio> #include <cstring> #include <cmath> #include <string> #include <iostream&

UVA 10534 Wavio Sequence

题解: 根据最长上升子序列的nlog(n)做法,求出以每个点结尾的最长上升子序列. 然后反过来再求一次 然后取最小值 * 2 - 1 即可 代码: #include<bits/stdc++.h> using namespace std; #define pb push_back #define mp make_pair #define se second #define fs first #define lson l,m,rt<<1 #define rson m+1,r,rt<

【UVA】10534 - Wavio Sequence(LIS最长上升子序列)

这题一看10000的数据量就知道必须用nlog(n)的时间复杂度. 所以特意去看了最长上升子序列的nlog(n)的算法. 如果有2个位置,该位置上的元素为A[i]和A[j],并且他们满足以下条件: 1.dp[i] = dp[j]    (dp[x]代表以x结尾的最长上升子序列长度) 2.A[i] < A[j] 3.i < j 那么毫无疑问,选择dp[i] 一定优于选择dp[j] 那么我们可以利用g[i]表示长度为i的序列的最后一个元素的最小值. 每次拿到一个A[i],在g[i]里面寻找到一个元

uva 10534 dp

UVA 10534 - Wavio Sequence 定义一种 Wavio 的序列.其长度为2*n+1,前n+1严格递增,后n+1个严格递减. 求在给的序列中找一个最长的 Wavio 子序列.输出长度. 正向LIS求出每个点以该点为结尾的最长上升子序列长度p[i],然后反向LIS求出以该点位开头的最长递减子序列长度q[i]. 然后枚举 Wavio 子序列的中点,该店的 Wavio 长度为 2 * min(p[i], q[i]) - 1; #include <cstdio> #include &